import java.net.*;
import java.io.*;
import java.applet.*;

/**
 * @author Simon Parsons
 * Modified 18th November
 *
 * The main work of this applet is done by the sendMessage method, which 
 * creates and sends a packet through a datagram socket. Calling this from
 * start() and stop() sends a message when the applet page is navigated to 
 * from.
 *
 * Based on the example from Learning Java, p 452.
 */
public class HeartBeat extends Applet{
    // A value for the myPort parameter will be passed in from the <param> tag
    String myHost;
    int myPort;

    // The passing in of the parameter is done here:
    public void init(){
	myHost = getCodeBase().getHost();
	myPort = Integer.parseInt(getParameter("myPort"));
    }
    
    // sendMessage assembles a datagram and sends it off with message in
    // it.
    private void sendMessage(String message){
	try{
	    // data is long enough to hold message encoded using UTF-8
	    byte[] data = message.getBytes("UTF-8");
	    
	    // Assemble the message
	    InetAddress address = InetAddress.getByName(myHost);
	    DatagramPacket packet = 
		new DatagramPacket(data, data.length, address, myPort);

	    // open the socket, send the message and close the socket
	    DatagramSocket dSock = new DatagramSocket();
	    dSock.send(packet);
	    dSock.close();
	}
	catch(IOException iox){
	    System.out.println(iox);
	}
    }

    // start() and stop() both call sendMessage
    public void start(){
	sendMessage("Arrived");
    }

    public void stop(){
	sendMessage("Departed");
    }
}