import java.net.*;
import java.io.*;

/**
 * @author Simon Parsons
 * Modified 18th November
 * 
 * A server that waits for a datagram packet and prints a message when
 * one arrives.
 *
 * Based on Learning Java, p 453
 */
public class Pulse {
    public static void main(String[] args) throws IOException{

	// Create a datagram socket that opens a port specified by
	// the first argument to Pulse.
	DatagramSocket dSock =
	    new DatagramSocket(Integer.parseInt(args[0]));

	while(true){
	    // Create a 1024 byte datagram packet. First argument is the packet
	    // itself, the second is the length of the packet in bytes.
	    DatagramPacket packet =
		new DatagramPacket(new byte[1024], 1024);
	    // Instantiate the packet with 1024 bytes of data from the socket.
	    // The program will wait here until it receives the data.
	    dSock.receive(packet);
	    // Extract the data from the packet into the String message and
	    // print it.
	    String message = 
		new String(packet.getData(), 0, packet.getLength(), "UTF-8");
	    System.out.println("Heartbeat from: " + 
	        packet.getAddress().getHostName() + " - " + message);
	}
    }
}